# coding: utf-8

"""
    DJ Set Downloader API

    A REST API for downloading and processing DJ sets, splitting them into individual tracks.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from dj_set_downloader.models.progress_stage import ProgressStage
from dj_set_downloader.models.progress_track_details import ProgressTrackDetails
from typing import Optional, Set
from typing_extensions import Self

class ProgressEvent(BaseModel):
    """
    ProgressEvent
    """ # noqa: E501
    data: Optional[List[StrictInt]] = None
    error: Optional[StrictStr] = None
    message: Optional[StrictStr] = None
    progress: Optional[Union[StrictFloat, StrictInt]] = None
    stage: Optional[ProgressStage] = None
    timestamp: Optional[StrictStr] = None
    track_details: Optional[ProgressTrackDetails] = Field(default=None, alias="trackDetails")
    __properties: ClassVar[List[str]] = ["data", "error", "message", "progress", "stage", "timestamp", "trackDetails"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ProgressEvent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of track_details
        if self.track_details:
            _dict['trackDetails'] = self.track_details.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ProgressEvent from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "data": obj.get("data"),
            "error": obj.get("error"),
            "message": obj.get("message"),
            "progress": obj.get("progress"),
            "stage": obj.get("stage"),
            "timestamp": obj.get("timestamp"),
            "trackDetails": ProgressTrackDetails.from_dict(obj["trackDetails"]) if obj.get("trackDetails") is not None else None
        })
        return _obj


